#include "main.h"


void start_meas( void ) {
	if( W1_IN & 1<< W1_PIN ) {
    	w1_command( CONVERT_T, NULL );
   	 	W1_OUT |= 1<< W1_PIN;
    	W1_DDR |= 1<< W1_PIN;			// parasite power on
  	} else {
		// short Circuit
  	}
}


void read_meas( unsigned char *s )
{
  	uchar id[8], diff;
  	uchar i;
  	uint temp;

  	for( diff = SEARCH_FIRST; diff != LAST_DEVICE; ) {
    	diff = w1_rom_search( diff, id );

    	if( diff == PRESENCE_ERR ) {
			sprintf( s, "no Sensor Found" );
			return;
    	}

    	if( diff == DATA_ERR ) {
			sprintf( s, "bus error" );
      		return;
    	}

    	if( id[0] == 0x28 || id[0] == 0x10 ) {		// temperature sensor
      		w1_byte_wr( READ );						// read command
      		temp = w1_byte_rd();					// low byte
      		temp |= (uint)w1_byte_rd() << 8;		// high byte
      		if( id[0] == 0x10 )						// 9 -> 12 bit
        		temp <<= 3;

			unsigned char temp[20];
			sprintf( temp, "%2X-%2X-%2X-%2X-%2X", id[0], id[1], id[2], id[3], id[4] );
			lcd_string_xy( temp, 0, 1 );
			sprintf( temp, "%2X-%2X-%2X-%2X", id[5], id[6], id[7], id[8] );
			lcd_string_xy( temp, 0, 2 );

//      		sprintf( s, "%4d.%01d C", temp >> 4, (temp << 12) / 6553 ); // 0.1C
    	}
  	}
}
